var HaGlobalData = {
  url: "/apps/ha/includes/index.php", //"/wmi/index.php"; //接口请求路径
  lastStartTime : 0,
}
window.halastTimer = null;
var hastatus = {
  available: UNAS._('##$@ha@$##High Availability is not configured##$@ha@$##'),
  running: UNAS._('##$@ha@$##High Availability is running##$@ha@$##'),
  config_failed: UNAS._('##$@ha@$##An error has occurred while creating##$@ha@$##'),
  configuring: UNAS._('##$@ha@$##Creating High Availability##$@ha@$##'),
  unknown: UNAS._('##$@ha@$##Unknown status##$@ha@$##')
}

function haManagerTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

function haManagerLoadingShow() {
  jQuery('#haManager_waiting_content').show();
  jQuery('#haManager_waiting_logo').show();
}

function haManagerLoadingHide() {
  jQuery('#haManager_waiting_content').hide();
  jQuery('#haManager_waiting_logo').hide();
}

//确认弹窗
function haManagerAlertWindow(title, text, fn, isck, cktext, tips) {
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(title),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 200,
    contentURL: '/apps/ha/alert.html?v=6.1.14&text=' + text + '&showcheckbox=' + isck + "&cktext=" + cktext + '&tips=' + tips
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

//确认弹窗
function errWindow(text, fn) {
  var errWindow = new MUI.Modal({
    id: 'jv-errWindow',
    title: UNAS._('##$@ha@$##Tips##$@ha@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 120,
    contentURL: '/apps/ha/errmsg.html?v=6.1.14&text=' + text
  });
  errWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function setDomID_HA() {
  var d = new Date().getTime();
  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = (d + Math.random() * 16) % 16 | 0;
    d = Math.floor(d / 16);
    return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
  });
  return uuid;
};
