var replacememberWindow = window.top.UNAS.GetWindow('jv-replacememberWindow');
var memberdata = replacememberWindow.options.data;
var replacetype = replacememberWindow.options.replacetype;

//扫描局域网
function member_scan_lan() {
  jQuery('#jv-createha-loading').show();
  member_get_probe().then(function() {
    jQuery('#jv-createha-loading').hide();
  })
}

function setoption(target, data, type) {

  jQuery(target).html('');
  var n = 0;
  for (var s in data) {
    if (data[s].length) {
      n = 1;
    }
    var optgroup = document.createElement("optgroup");
    var op = '';
    if (s == 'available') {
      jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Available##$@ha@$##'));
      if (data[s].length) {
        for (var i = 0; i < data[s].length; i++) {
          var t = '';
          if (type == 'disks') {
            t = data[s][i].disk + ' (' + UNAS.getReadableSizeString(data[s][i].size) + ')';
            op += '<option value=' + data[s][i].disk + '>' + t + '</option>';
          } else {
            var selected = '';
            if (type == "heartbeat" && data[s][i].type == "heartbeat") {
              selected = 'selected';
            }
            t = data[s][i].ifname + ' (' + (data[s][i].ip || '--') + '/' + (data[s][i].mask || '--') + ')';
            if (type == 'service') {
              op += '<option value="' + (data[s][i].ifname + "/" + (data[s][i].ip || '--')) + '">' + t + '</option>';
            } else {
              op += '<option value="' + (data[s][i].ip || '--') + '"' + selected + '>' + t + '</option>';
            }
          }
        }
      } else {
        if (type == 'disks') {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available volume##$@ha@$##') + '</option>';
        } else {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available iface##$@ha@$##') + '</option>';
        }
      }

      jQuery(optgroup).html(op);
    }
    if (s == 'unavailable') {
      jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Unavailable##$@ha@$##')).attr('disabled', 'disabled');
      if (data[s].length) {
        for (var j = 0; j < data[s].length; j++) {
          var t = '';
          if (type == 'disks') {
            t = data[s][j].disk + ' (' + UNAS.getReadableSizeString(data[s][j].size) + ')';
            op += '<option value=' + data[s][j].disk + '>' + t + '</option>';
          } else {
            t = data[s][j].ifname + ' (' + (data[s][j].ip || '--') + '/' + data[s][j].mask + ')';
            if (type == 'service') {
              op += '<option value="' + (data[s][j].ifname + "/" + data[s][j].ip) + '">' + t + '</option>';
            } else {
              op += '<option value="' + data[s][j].ifname + '">' + t + '</option>';
            }
          }
        }
      } else {
        if (type == 'disks') {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable volume##$@ha@$##') + '</option>';
        } else {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable iface##$@ha@$##') + '</option>';
        }
      }

      jQuery(optgroup).html(op);
    }

    jQuery(target).append(optgroup);

    jQuery(target).off('change').on('change', function() {
      changeBtn();
    })

  }
}
//获取局域网机器
function member_get_probe() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'probe',
        token: UToken
      }),
      timeout: 60000,
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          var info = data.results || [];
          if (!info.length) {
            return;
          }
          var host = {
            available: [],
            unavailable: []
          }
          for (var i = 0; i < info.length; i++) {
            var d = info[i];
            if (d.status == "available") {
              host.available.push(d);
            } else {
              host.unavailable.push(d);
            }
          }
          jQuery('#jv-slavename').attr('hostname', info[0].hostname);
          jQuery('#jv-lans').html('');
          for (var s in host) {
            var optgroup = document.createElement("optgroup");
            var op = '';
            if (s == 'available') {
              jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Available##$@ha@$##'));
              if (host[s].length) {
                for (var i = 0; i < host[s].length; i++) {
                  var t = '';
                  var ip = '';
                  for (var ac = 0; ac < host[s][i].ifaces.length; ac++) {
                    ip += (host[s][i].ifaces[ac].ip || '--') + "/";
                  }

                  t = host[s][i].hostname + ' (' + ip + ')';
                  op += "<option value='" + JSON.stringify(host[s][i]) + "'>" + t + "</option>";
                }
              } else {
                jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
                op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available machine##$@ha@$##') + '</option>';
              }

              jQuery(optgroup).html(op);
            }
            if (s == 'unavailable') {
              jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Unavailable##$@ha@$##')).attr('disabled', 'disabled');
              if (host[s].length) {
                for (var j = 0; j < host[s].length; j++) {
                  var t = '';
                  var ip = '';
                  for (var ac = 0; ac < host[s][j].ifaces.length; ac++) {
                    ip += host[s][j].ifaces[ac].ip + "/";
                  }

                  t = host[s][j].hostname + ' (' + ip + ')';
                  op += '<option value="' + ip + '">' + t + '</option>';
                }
              } else {
                op = '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable machine##$@ha@$##') + '</option>';
              }
              jQuery(optgroup).html(op);
            }

            jQuery('#jv-lans').append(optgroup);
          }

          var service = {
            available: [],
            unavailable: []
          }
          var heartbeat = {
            available: [],
            unavailable: []
          }

          jQuery('#jv-lans').off('change').on('change', function() {
            var ips = JSON.parse(jQuery(this).val());
            var ifaces = JSON.parse(ips.ifaces);
            var s_ = {
                available: [],
                unavailable: []
              },
              h_ = {
                available: [],
                unavailable: []
              };
            for (var i = 0; i < ifaces.length; i++) {
              var t_ = ifaces[i];
              if (i == 1) {
                t_['type'] = 'heartbeat'
              }
              s_.available.push(t_);
              h_.available.push(t_);
              jQuery('#jv-slavename').attr('hostname', ips.hostname);
            }
            setoption('#jv-service', s_, 'service');
            setoption('#jv-heartbeat', h_, 'heartbeat');
            changeBtn();
          });

          for (var i = 0; i < host.available[0].ifaces.length; i++) {
            var t_ = host.available[0].ifaces[i];
            if (i == 1) {
              t_['type'] = 'heartbeat'
            }
            service.available.push(t_);
            heartbeat.available.push(t_);

          }

          setoption('#jv-service', service, 'service');
          setoption('#jv-heartbeat', heartbeat, 'heartbeat');

        }

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        resolve(xhr);
      }
    });
  })

}

function changeBtn() {
  var service = jQuery('#jv-service').val().split("/")[1];
  service = service == '--' ? '' : service;
  var heartbeat = jQuery('#jv-heartbeat').val();
  heartbeat = heartbeat == '--' ? '' : heartbeat;
  var lans = jQuery('#jv-lans').val();
  var pwd1 = jQuery('#jv-pwd-1').val();

  if (service && heartbeat && pwd1) {
    jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub');
  } else {
    jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
  }
}


function replace_member() {

  return new Promise(function(resolve, reject) {
    jQuery('#jv-createha-loading').show();
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'replace_slave',
        token: UToken,
        params: {
          "old": memberdata.name,
          "host": jQuery('#jv-slavename').attr('hostname'),
          "hb_ip": jQuery('#jv-heartbeat').val(),
          "ip": jQuery('#jv-service').val().split("/")[1],
          "pass": jQuery('#jv-pwd-1').val()
        }
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          var info = data.results || {};
          MUI.closeWindow($('jv-replacememberWindow'));
          ha_status();
        } else {
          errWindow(UNAS._('##$@ha@$##' + data.errmsg + '##$@ha@$##'), function() {
            jQuery('#jv-createha-loading').hide();
          });
        }
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {

      }
    });
  })
}

(function() {

  member_scan_lan();

  jQuery('#jv-pwd-1').bind('input propertychange', function() {
    changeBtn();
  })
})()
